package test;
import java.util.Collection;
import card.Card;
public class CommonCardTest {
	protected static interface TestIntMethod{
		int perform(Card e);
	}
	private static final int len = 10;
	protected static String[] randomStringArray(int n){
		String[] result = new String[n];
		for(int i=0; i<n; i++){
			StringBuilder sb = new StringBuilder();
			for(int j=0; j<len; j++){
				sb.append('A'+Math.random()*('Z'-'A'+1));
			}
			result[i]=sb.toString();
		}
		return result;
	}
	protected static int[] toIntArray(Collection<? extends Card> arg, TestIntMethod b){
		int[] result = new int[arg.size()];
		int i=0;
		for(Card e : arg){
			result[i++]=b.perform(e);
		}
		return result;
	}
	public static class Id implements TestIntMethod {
		@Override
		public int perform(Card e) {
			return e.id();
		}
	}
	public static class Rate implements TestIntMethod {
		@Override
		public int perform(Card e) {
			return e.rate();
		}
	}
	protected interface TestObjectMethod<F> {
		F perform(Card e);
	}
	protected static <F> F[] toObjectArray(Collection<? extends Card> arg, TestObjectMethod<F> b){
		@SuppressWarnings("unchecked")
		F[] result = (F[]) new Object[arg.size()];
		int i=0;
		for(Card e : arg){
			result[i++]=b.perform(e);
		}
		return result;
	}
	public static class ToString implements TestObjectMethod<String>{
		@Override
		public String perform(Card e) {
			return e.toString();
		}
	}
	public static class Name implements TestObjectMethod<String>{
		@Override
		public String perform(Card e) {
			return e.name();
		}
	}
	static int[] getIntArray(int start, int size) {
		int[] result = new int[size];
		int j=start;
		for(int i=0; i<size; i++){
			result[i]=j++;
		}
		return result;
	}
}