package test;
import static org.junit.Assert.*;
import java.util.Arrays;
import java.util.List;
import org.junit.Before;
import org.junit.Test;
import card.Card;
import card.CardFactory;
import card.Rare;
public class RareTest extends CommonCardTest {
	private static final String[] name1 = {"RareAka","RareAo","RareKuro"};
	private String[] name2;
	private List<Card> list1;
	private List<Card> list2;
	private CardFactory factory1;
	private CardFactory factory2;
	private CardTestScenario<Card> cardTestScenario1;
	private CardTestScenario<Card> cardTestScenario2;
	@Before
	public void setup(){
		name2 = randomStringArray(Constant.TESTLENGTH);
		factory1 = new CardFactory(10,name1,new Rare());
		factory2 = new CardFactory(110,name2,new Rare());
		list1 = factory1.getList();
		list2 = factory2.getList();
		cardTestScenario1 = new CardTestScenario<Card>(list1);
		cardTestScenario2 = new CardTestScenario<Card>(list2);
	}
	private static class RareClassTest implements CardTestScenario.Tester<Card>{
		@Override
		public boolean check(Card card) {
			return card instanceof Rare;
		}
	}
	@Test
	public void testClass(){
		cardTestScenario1.setTest(new RareClassTest());
		cardTestScenario1.execCheck();

		cardTestScenario2.setTest(new RareClassTest());
		cardTestScenario2.execCheck();
	}
	@Test
	public void testRate() {
		int[] exp1 = new int[name1.length];
		Arrays.fill(exp1, 100);
		assertArrayEquals(exp1, toIntArray(list1,new Rate()));

		int[] exp2 = new int[name2.length];
		Arrays.fill(exp2, 100);
		assertArrayEquals(exp2, toIntArray(list2,new Rate()));
	}
	@Test
	public void testToString(){
		assertArrayEquals(name1, toObjectArray(list1,new ToString()));
		assertArrayEquals(name2, toObjectArray(list2,new ToString()));
	}
	@Test
	public void testName(){
		assertArrayEquals(name1, toObjectArray(list1,new Name()));
		assertArrayEquals(name2, toObjectArray(list2,new Name()));
	}
	@Test
	public void testOrder() {
		int[] exp1 = CommonCardTest.getIntArray(10,list1.size());
		assertArrayEquals(exp1, toIntArray(list1,new Id()));
		int[] exp2 = CommonCardTest.getIntArray(110,list2.size());
		assertArrayEquals(exp2, toIntArray(list2,new Id()));
	}
	@Test
	public void testCompareTo() {
		cardTestScenario1.testCompareTo();
		cardTestScenario2.testCompareTo();
	}
}
